# config.linux
# 
# This configuration file is read by Makefiles in ./src and ./doc directories.
#
# Customize as needed.
# 
# No other customization should be necessary.

# where to install program, man page, on-line help files
# and stand-alone html documentation
PREFIX	= /usr/local/stow/dynagraph
BINDIR	= $(PREFIX)/bin
MANDIR	= $(PREFIX)/man/man1
HTMLDIR = $(PREFIX)/share/dynagraph/html
HELPDIR	= $(PREFIX)/share/dynagraph/help

# choice of compiler and its flags
CC	= gcc
CCOPTS	= -Wall -O2

# options for the linker
LDFLAGS	= #-s

# non-standard paths to library header files; leave blank if not needed
# 
# note that Xforms library's header file, forms.h, often is installed
# in non-standard places
I_PATHS = -I/usr/local/include

# non-standard paths to libraries; leave blank if not needed
L_PATHS	= -L/usr/local/lib #-L/usr/lib/termcap

# libraries
LIBS	= $(L_PATHS) \
		-lformsGL -lforms -lXpm -lreadline -ltermcap \
		-ltiff -ljpeg -lpng -lGL -lX11 -lXext -lz -lm

