#include <stdlib.h>
#include <string.h>
#include "hoc.h"
#include "hoc-parse.h"	/* automatically generated by yacc -d */

static Symbol *symlist = 0;  /* symbol table: linked list */

void clear_symlist(void)	/* addes by RR */
{
	Symbol *p, *q;

	p = symlist;
	while (p != NULL) {
		q = p->next;
		free(p);
		p = q;
	}
	symlist = NULL;
}

Symbol* lookup(char* s)	/* find s in symbol table */
{
	Symbol *sp;

	for (sp = symlist; sp != (Symbol *) 0; sp = sp->next)
		if (strcmp(sp->name, s) == 0)
			return sp;
	return 0;	/* 0 ==> not found */	
}

Symbol* install(char* s, int t, double d)  /* install s in symbol table */
{
	Symbol *sp;

	sp = emalloc(sizeof(Symbol));
	sp->name = emalloc(strlen(s)+1); /* +1 for '\0' */
	strcpy(sp->name, s);
	sp->type = t;
	sp->u.val = d;
	sp->next = symlist; /* put at front of list */
	symlist = sp;
	return sp;
}

void* emalloc(unsigned n)	/* check return from malloc */
{
	char *p;

	p = malloc(n);
	if (p == 0)
		execerror("out of memory", (char *) 0);
	return p;
}
