#include <stdlib.h>
#include <forms.h>
#include <GL/gl.h>
#include "dynagraph.h"
#include "formdefs.h"

extern FD_form		*Form;

/* This routine is called when user closes the form through the window
   manager functions.  Be returning FL_OK, we are allowing the widow
   to be closed, but xforms continues to run. */
static int form_atclose(FL_FORM *form, void *data)
{
	FL_OBJECT *glCanvas = Form->glCanvas;

	remove_canvas_handlers();
	free_plotlist(glCanvas->u_vdata);
	fl_hide_form(Form->form);
	fl_free_form(Form->form);
	free(Form);
	Form = NULL;
	return FL_OK;
}

void create_form(void)
{
	Form = create_form_form();

	fl_set_form_atclose(Form->form, form_atclose, NULL);
	fl_set_form_minsize(Form->form, Form->form->w, Form->form->h);
	fl_setpup_default_pup_checked_color(FL_GREEN);

	create_menus();

	fl_set_button(Form->framecounterbutton, 1);

	fl_set_dial_return(Form->zoomdial, FL_RETURN_CHANGED);
	fl_set_dial_return(Form->brightnessdial, FL_RETURN_CHANGED);

	/* default button settings */
	fl_set_button(Form->light_button, 1);
	fl_set_button(Form->hilight_button, 1);
	fl_set_button(Form->constrained_scaling_button, 1);
	fl_set_button(Form->toggle_box_button, 0);
}
