#ifndef DG_PARSE_H
#define DG_PARSE_H

#include "dynagraph.h"

/* return values of the symbolic parser */
enum parse_return {
	PP_EOI	=0,	/* end of input (0 is yacc's built-in value on EOF) */
	PP_ERROR=1,	/* error (1 is yacc's built-in return value on error) */
	PP_READ,		/* read from file	(read(filename);) */
	PP_SAVEGRAPH,		/* save graph to file	(savegraph(id, fmt, file);) */
	PP_SHOW,		/* show symbol's value	(id;) */
	PP_DUMP,		/* dump symbol table	(dump;) */
	PP_RESTART,		/* restart session	(restart;) */
	PP_ASGN,		/* asignment:		(id := expr;) */
	PP_PLOT,		/* plot			(plot3d(...);) */
	PP_DISPLAY,		/* display a plot list	(display([p1,p2,..]);)*/
	PP_SPACECURVE,		/* spacecurce		(spacecurve(...);) */
	PP_TUBEPLOT,		/* tubeplot		(tubeplot(...);) */
	PP_POLYGONPLOT,		/* polygonplot		(polygonplot(...);) */
	PP_TEXTPLOT,		/* textplot		(textplot(...);) */
	PP_DATAPLOT,		/* dataplot		(dataplot(...);) */
	PP_PLOT_SAVE,		/* save plot		(id := plot3d(...):) */
	PP_PLOT_SAVE_SHOW,	/* save plot		(id := plot3d(...);) */
	PP_DISP_SAVE,		/* save merge plots	(id := display(...):) */
	PP_DISP_SAVE_SHOW,	/* save merge plots	(id := display(...);) */
	PP_DATAPLOT_SAVE,	/* dataplot		(id := dataplot(...):)*/
	PP_DATAPLOT_SAVE_SHOW	/* dataplot		(id := dataplot(...);)*/
};

#define RLIMIT          32      /* recursion limit in symbol evaluation */

#endif /* DG_PARSE_H */
