#include <stdio.h>
#include <jpeglib.h>

#define QUALITY		100

void write_jpeg(char *file, unsigned char *image, unsigned int w, unsigned int h)
{
	struct jpeg_compress_struct cinfo;
	struct jpeg_error_mgr jerr;
	int row_stride;
	JSAMPROW row_pointer;
	FILE *fp;
	int i;

	if ((fp=fopen(file, "w"))==NULL) {
		printf("\terror: unable to open file '%s' for writing\n", file);
		return;
	}

	cinfo.err = jpeg_std_error(&jerr);
	jpeg_create_compress(&cinfo);
	jpeg_stdio_dest(&cinfo, fp);
	cinfo.image_width = w;
	cinfo.image_height = h;
	cinfo.input_components = 3;
	cinfo.in_color_space = JCS_RGB;
	jpeg_set_defaults(&cinfo);
	jpeg_set_quality(&cinfo, QUALITY, TRUE);
	jpeg_start_compress(&cinfo, TRUE);
	row_stride = 3*w;

	for (i=h-1; i>=0; i--) {
		row_pointer = &image[i*row_stride];
		jpeg_write_scanlines(&cinfo, &row_pointer, 1);
	}

	jpeg_finish_compress(&cinfo);
	jpeg_destroy_compress(&cinfo);

	fclose(fp);
}
