#include <stdio.h>
#include <png.h>
#include <setjmp.h>

extern char *prognam;

void write_png(char *file, unsigned char *image, unsigned int w, unsigned int h)
{
	FILE *fp;
	png_structp png_ptr;
	png_infop info_ptr;
	png_bytep row_pointer;
	int i;

	if ((fp=fopen(file, "w"))==NULL) {
		printf("\terror: unable to open file '%s' for writing\n", file);
		return;
	}

	png_ptr = png_create_write_struct(PNG_LIBPNG_VER_STRING,
			NULL, NULL, NULL);

	if (png_ptr==NULL) {
		printf("\terror: an error occured in the PNG library initialization\n");
		printf("\terror: possibly a version mismatch with the expected libpng %s\n",
				PNG_LIBPNG_VER_STRING);
		fclose(fp);
		return;
	}

	info_ptr = png_create_info_struct(png_ptr);
	if (info_ptr==NULL) {
		printf("\terror: out of memory in the PNG library initialization\n");
		fclose(fp);
		png_destroy_write_struct(&png_ptr, (png_infopp) NULL);
		return;
	}

	if (setjmp(png_ptr->jmpbuf)) {
		printf("\terror: an error occured in the PNG library initialization\n");
		fclose(fp);
		png_destroy_write_struct(&png_ptr, (png_infopp) NULL);
		return;
	}

	png_init_io(png_ptr, fp);

	png_set_IHDR(png_ptr, info_ptr, w, h, 8,
			PNG_COLOR_TYPE_RGB, PNG_INTERLACE_NONE,
			PNG_COMPRESSION_TYPE_BASE, PNG_FILTER_TYPE_BASE);


	/* ready to write PPM file */

	/* write file header info */
	png_write_info(png_ptr, info_ptr);
	
	for (i=h-1; i>=0; i--) {
		row_pointer = &image[i*3*w];
		png_write_rows(png_ptr, &row_pointer, 1);
	}

/* 	png_write_image(png_ptr, row_pointers); */

	png_write_end(png_ptr, info_ptr);

	png_destroy_write_struct(&png_ptr, (png_infopp)NULL);

	fclose(fp);
}
