/* Postscript headers and trailers for write_ps() and write_cps() commands
   are copied from John Bradley's xv program.
*/

#include <stdio.h>
#include "dynagraph.h"		/* for the DYNAGRAPH_VERSION string */

extern char *prognam;

/* save file in Color Postscript format */
void write_cps(char *file, unsigned char *image, unsigned int w, unsigned int h)
{
	FILE *fp;
	unsigned char *p;
	unsigned int x, y;
	int i, counter;

	if ((fp=fopen(file, "w"))==NULL) {
		printf("\terror: unable to open file '%s' for writing\n", file);
		return;
	}

	/* ready to write Postscript file */
	p = image;

#include "ps-header-color.h"

	for (y=h; y>0; ) {
		y--;
		counter=0;
		for (x=0; x<w; x++) {
			i = (y*w + x) * 3;
			fprintf(fp, "%02x%02x%02x", p[i], p[i+1], p[i+2]);
			counter++;
			if (counter%12 == 0)	/* 72 char per line */
				fprintf(fp, "\n");
		}
		if (counter%12 != 0)
			fprintf(fp, "\n");
	}

#include "ps-trailer.h"

	fclose(fp);
}

/* save file in Grayscale Postscript format */
void write_ps(char *file, unsigned char *image, unsigned int w, unsigned int h)
{
	FILE *fp;
	unsigned char *p;
	unsigned int x, y;
	int i, counter;

	if ((fp=fopen(file, "w"))==NULL) {
		printf("\terror: unable to open file '%s' for writing\n", file);
		return;
	}

	/* ready to write Postscript file */
	p = image;

#include "ps-header-gray.h"

	for (y=h; y>0; ) {
		y--;
		counter=0;
		for (x=0; x<w; x++) {
			i = (y*w + x) * 3;
			fprintf(fp, "%02x", (20*p[i]+32*p[i+1]+12*p[i+2])/64);
			counter++;
			if (counter%36 == 0)	/* 72 char per line */
				fprintf(fp, "\n");
		}
		if (counter%36 != 0)
			fprintf(fp, "\n");
	}

#include "ps-trailer.h"

	fclose(fp);
}
