/* writetiff() modeled after the routine in osmesa.c distributed with Mesa
   and ideas from glut-3.6/progs/tiff/writetiff.c in Mark J. Kilgard's GLut
   distribution.
*/

#include <stdio.h>
#include <tiffio.h>

void write_tiff(char *file, unsigned char *image, unsigned int w, unsigned int h)
{
	unsigned char *p;
	TIFF *fp;
	int i;

	if ((fp=TIFFOpen(file,"w"))==NULL) {
		printf("\terror: unable to open file '%s' for writing\n", file);
		return;
	}

	TIFFSetField(fp, TIFFTAG_IMAGEWIDTH, (uint32)w);
	TIFFSetField(fp, TIFFTAG_IMAGELENGTH, (uint32)h);
	TIFFSetField(fp, TIFFTAG_BITSPERSAMPLE, 8);
	TIFFSetField(fp, TIFFTAG_COMPRESSION, COMPRESSION_LZW);
	TIFFSetField(fp, TIFFTAG_PHOTOMETRIC, PHOTOMETRIC_RGB);
	TIFFSetField(fp, TIFFTAG_SAMPLESPERPIXEL, 3);
	TIFFSetField(fp, TIFFTAG_PLANARCONFIG, PLANARCONFIG_CONTIG);
	TIFFSetField(fp, TIFFTAG_ROWSPERSTRIP, 1);

	p = image;

	for (i=h-1; i>=0; i--) {
		if (TIFFWriteScanline(fp, p, i, 0) < 0)
			break;
		p += w * 3;
	}

	TIFFClose(fp);
}
